<?php
// $Id: 55_AnonFtp.php.default.Vsite
// AnonFtp.php.create.Vsite
// Copyright (c) 2014 Michael Stauber, SOLARSPEED.NET
// Copyright (c) 2014 Team BlueOnyx, BLUEONYX.IT

include_once('UIExtension.php');

//class AnonFtpExtension extends UIExtension
class AnonFtpExtension extends UIExtension
{
    function display(&$ServerScriptHelper, &$container, $parameters)
    {
        $factory = $ServerScriptHelper->getHtmlComponentFactory("base-ftp");
        $cce = $ServerScriptHelper->getCceClient();

        $defaults =& $cce->get($parameters["CCE_SERVICES_OID"], "AnonFtp");

        // construct all the form fields needed, note that only simple
        // form fields are allowd.  no composite form fields
        $ftpQuota =& $factory->getInteger("ftpQuota", $defaults["quota"], 1);
        $ftpQuota->setType('memdisk');

        $ftpUsers =& $factory->getInteger("ftpUsers", $defaults["maxConnections"], 1);
        $ftpUsers->setType('number');
    
        $pageId = $parameters['PAGED_BLOCK_DEFAULT_PAGE'];
 
        $anonFtp =& $factory->getMultiChoice('anonFtp');
        $enable =& $factory->getOption("anonEnable", $defaults["enabled"]);
        $enable->setLabel($factory->getLabel('anonEnable', false));
        
        $enable->addFormField($ftpQuota, $factory->getLabel("ftpQuota"), $pageId);
        $enable->addFormField($ftpUsers, $factory->getLabel("ftpUsers"), $pageId);
        $anonFtp->addOption($enable);
        
        $container->addFormField(
                    $anonFtp,
                    $factory->getLabel('anonFtp'),
                    $pageId);

    }

    function handle(&$ServerScriptHelper, &$errors, $parameters, &$attributes)
    {
        // have to claim all the globals needed or this function won't be able to see them
        //global $AnonFtp_enabled, $AnonFtp_quota, $AnonFtp_maxConnections;
        $this->attributes = $attributes;

        $cce = $ServerScriptHelper->getCceClient();

        $anonFtp_enabled = "0";
        if (isset($this->attributes['anonFtp'])) {
            if ($this->attributes['anonFtp'] == "1") {
                $anonFtp_enabled = "1";
            }
        }
        
        // simply set the values in CCE
        $cce->set($parameters["CCE_SERVICES_OID"], "AnonFtp",
            array(
                "enabled" => $anonFtp_enabled, 
                "quota" => unsimplify_number($this->attributes['ftpQuota'], "KB"), 
                "maxConnections" => $this->attributes['ftpUsers']
            ));

        // add any errors that occured so they can get back to the UI
        $errors = array_merge($errors, $cce->errors());
    }

}
?>
